open Ca

class spirals width height =
  object
  inherit cellular_automata width height as p
  val states = 4

  method f x y = let nlc = ref 0 in
    let c = (state.(x).(y))#get_state in
    let t = (c+1) mod 4 in
    for i=(-1) to 1 do
      for j=(-1) to 1 do
        if not (i=0 && j=0) && (state.(p#pw (x+i)).(p#ph (y+j)))#get_state = t then incr nlc
      done
    done ;
    if !nlc >= 2 then new cell t else new cell c
end