open Ca

class starwars width height =
  object
  inherit cellular_automata width height as p
  val states = 4

  method f x y = let nlc = ref 0 in
    for i=(-1) to 1 do
      for j=(-1) to 1 do
        if not (i=0 && j=0) && (state.(p#pw (x+i)).(p#ph (y+j)))#get_state =1 then incr nlc
      done
    done ;
    let c = (state.(x).(y))#get_state in
    match c with
    | 0 -> if !nlc=2 then new cell 1 else new cell 0
    | n -> if !nlc=3 || !nlc=4 || !nlc=5 then new cell c else new cell ((n+1) mod 4)
end